"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxiesRawMapper = exports.ProxiesMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class ProxiesMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('proxy', {
            key: 'proxy',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('totalWeight', {
            key: 'total_weight',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { proxy, total_weight, _id, ...rest } = mongoModel;
        return entities_1.Proxies.create(proxy || '', total_weight || 0, _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.ProxiesMongoMapper = ProxiesMongoMapper;
class ProxiesRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { proxy, total_weight, ...rest } = rawModel;
        return entities_1.Proxies.create(proxy || '', total_weight || 0, undefined, rest);
    }
}
exports.ProxiesRawMapper = ProxiesRawMapper;
